package utility;
import java.io.File;
import java.io.IOException;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Date;

import org.eclipse.paho.client.mqttv3.IMqttDeliveryToken;
import org.eclipse.paho.client.mqttv3.MqttCallback;
import org.eclipse.paho.client.mqttv3.MqttException;
import org.eclipse.paho.client.mqttv3.MqttMessage;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import scenari.Automa;
import scenari.Scenari;

public class SubscribeCallback implements MqttCallback{
	
	private Scenari scenari;
//	private Publisher publisher;
	private String learnTrigger;
	private String attivaScenari;
	private Esecutore esec;
	private Automa automa;
	
	public SubscribeCallback(Scenari scenari/*, Publisher publisher*/, String learnTrigger, String attivaScenari, Esecutore esec, Automa automa) {
		this.scenari = scenari;
//		this.publisher = publisher;
		this.learnTrigger = learnTrigger;
		this.attivaScenari = attivaScenari;
		this.esec = esec;
		this.automa = automa;
	}

	@Override
	public void connectionLost(Throwable arg0) {
		System.out.println("connessione persa\t"+arg0);
//		boolean retry = true;
		final Date d = new Date();
		Date d2 = new Date();
		long time = Math.abs(d2.getTime()-d.getTime());
		
		while(/*retry ||*/ (time<600000)) {
			try {
				System.out.println("retrying...");
				
				Scenari.main(null);
				return;
//				esec.interrupt();
//				publisher.interrupt();
//				publisher = new Publisher(new MyQueue<Pair>(), scenari);
//				esec = new Esecutore(publisher,automa);
				
//				scenari.startClient(esec, publisher);
//				retry = false;
			} catch (MqttException | JSONException | IOException e) {
				System.out.println("non sono riusciuto");
				d2 = new Date();
				time = Math.abs(d2.getTime()-d.getTime());
			}
		}
		System.out.println("fuori dal while");
		if(time>=600000) {
			System.out.println("Tentativo di riconnessione fallito");
			System.exit(1);
		}
	}

	
	@Override
	public void deliveryComplete(IMqttDeliveryToken arg0) {
		// Nessuna operazione
		System.out.println("inviato");
	}
	

	@Override
	public void messageArrived(String topic, MqttMessage message) throws MqttException, JSONException, IOException {
//		topic = topic.toLowerCase();
		System.out.println("new message: "+topic+"  "+message.toString());
		if(topic.equals("to/all")) {
			System.out.println("invio lo stato dell'automa");
			sendRequested(Scenari.getMqttTree("from/","scenari/description"),false);
			return;
		}
		if(topic.equals(Scenari.getMqttTree("rpc/","scenari"))) {
			System.out.println("invio la mia configurazione");
			sendRequested(Scenari.getMqttTree("from/","scenari"),true); // CONTROLLA SE VA BENE PUBBLICARE LO STATO SU QUESTO TOPIC O SE IL TOPIC DEVE ESSERE UN'ALTRO. NOTA: NON POSSO PUBBLICARE SULLO STESSO TOPIC CHE HO SOTTOSCRITTO
			return;
		}
		
		
		JSONObject msgJson = new JSONObject(message.toString());
		// CONTROLLA SULLA BEAGLEBONE CHE IL MESSAGGIO MANDATO SIA UN INT. CONTROLLA ANCHE IL TOPIC SU CUI MANDA I MESSAGGI (da aver sottoscritto i topic correttamente)
		
//		gli event sono 0 o 1; i trigger quando sono attivati/premuti inviano uno 0, che e' l'unico elemento che mi interessa
		if(topic.equals(Scenari.getMqttTree("from/","gpio/"+learnTrigger))) {
			System.out.println("trigger per learn\t"+!automa.getAntifurto());
			if(automa.getAntifurto())//se l'antifurto e' attivo, non posso attivare gli scenari
				return;
			int newStatus = msgJson.getInt("event");
			if(newStatus != 1)
				return;
			handleEvent(newStatus,learnTrigger);
			return;
		}
		if(topic.equals(Scenari.getMqttTree("from/","gpio/"+attivaScenari))) {
			System.out.println("trigger per antifurto\t"+!automa.getLearn());
			if(automa.getLearn())//se l'apprendimento e' attivo, non posso attivare l'antifurto
				return;
			int newStatus = msgJson.getInt("event");
			if(newStatus != 1)
				return;
			handleEvent(newStatus,attivaScenari);
			return;
		}
		if(topic.startsWith(Scenari.getMqttTree("from/","gpio/IN"))) {
			System.out.println("totalmente inutile per me!");
			return;//non mi interessa altro da IN
		}
//		if(topic.equals("to/"+Scenari.getMqttTree()+"scenari/learn")) {//mi aspetto un {learn:true/false}, scritto da handleEvent
//			System.out.println("messaggio per iniziare/terminare a imparare");
//			boolean val = msgJson.getBoolean("learn");
//			handleLearn(val);
//			return;
//		}
		if(topic.startsWith(Scenari.getMqttTree("from/","gpio/OUT"))) {
			if(message.toString().contains("event")) {
				System.out.println("se learn==true, salvo questo event!");
				System.out.println(automa.getLearn()+"\t"+msgJson.toString());
			}
			if(!automa.getLearn() || !message.toString().contains("event"))
				return;
			if(scenarioName == null) {
				handleLearn(true);
			}
			int val = msgJson.getInt("event");
			String luce = topic.substring(23);
			handleLearnData(luce,val);
			return;
		}
		if(topic.equals(Scenari.getMqttTree("to/","scenari"))) {
			System.out.println("Cambio quale scenario e' attivo, se antifurto attivo");
			if(!automa.getAntifurto() || !message.toString().contains("event") || !message.toString().contains("nome"))
				return;
			changeActiveScenario(msgJson);
			return;
		}
		if(topic.equals(Scenari.getMqttTree("to/","scenari/salva"))) {
			System.out.println("rinomino l'ultimo scenario salvato");
			if(automa.ultimoStato != 1 || !message.toString().contains("nome"))//se non sono appena stato nello stato di registrazione, non serve andare avanti
				return;
			renameLastScenario(msgJson);
			return;
		}
		
		System.out.println("Impossibile");
	}
	
	private void handleEvent(int newStatus,String which) throws JSONException, MqttException, IOException{
//		if(newStatus != 1)
//			return;
		String cosa = which == learnTrigger ? "learn" : "antifurto";
		String cmd = automa.findPossibleCommand(cosa);
		if(cmd == null)
			return;
		System.out.println("handling event: "+cosa+"\t"+cmd);
		automa.setStato(new JSONObject().put(cosa,cmd).toString());
		System.out.println("stato\t"+automa.getStato());
		if(Helper.compareText(cosa, "learn")) {
//			JSONObject j = new JSONObject().put("learn", Helper.compareText(cmd, "on"));
//			Helper.sendMqttMessage(scenari.mqttClient, "to/"+Scenari.getMqttTree()+"scenari/learn", j.toString());
//			publisher.aggiungiComando("to/"+Scenari.getMqttTree()+"scenari/learn", j.toString());//NON posso inviare ad un topic che subbo
			boolean val = Helper.compareText(cmd, "on");
			handleLearn(val);
			sendRequested(Scenari.getMqttTree("from/","scenari/learn"),false);
		} else 
			sendRequested(Scenari.getMqttTree("from/","scenari/antifurto"),false);
	}
	
	private String scenarioName = null;//"scenario"+LocalTime.now();
//	private LocalTime lastTime = null;
	
	private void handleLearn(boolean shouldLearn) throws JSONException, IOException{
		System.out.println("handleLearn "+shouldLearn+" ; "+automa.getLearn());
		automa.setStato("{\"learn\":"+ (shouldLearn ? "\"on\"" : "\"off\"")+"}");
		System.out.println("\t"+automa.getLearn());
		if(automa.getLearn()) {
			if(/*lastTime == null &&*/ scenarioName == null) {
//				lastTime = LocalTime.now();
				scenarioName = "scenario-"+LocalDateTime.now().toString().replace(':', '-')+".json";
			}
		} else {
//			lastTime = null;
			scenarioName = null;
//			TODO tell antifurto to turn off if shouldLearn == true
		}
	}
	
	private void handleLearnData(String luce, int val) throws MqttException, IOException, JSONException {
		JSONObject j = new JSONObject();
//		tempo passato dallo scorso comando
		LocalTime now = LocalTime.now();
//		long diff = Helper.timeDifference(lastTime,now);
		j.put("tempo", now.format(DateTimeFormatter.ofPattern("HH-mm-ss")));
//		lastTime = now;
//		quale luce
		j.put("luce", luce);
//		accesa o spenta?
		j.put("cmd", val);
		Helper.appendiFile(j, esec.DB_FOLDER+scenarioName,false);
	}
	
	private void changeActiveScenario(JSONObject scenario) throws IOException, JSONException, MqttException {
		String nuovoScenario = esec.getUCS().requestToChange(scenario);
		System.out.println(nuovoScenario);
		JSONObject j = new JSONObject();
		j.put("nome", nuovoScenario);
		scenari.sendMqttMessage(Scenari.getMqttTree("from/","/scenari/attiva"), j.toString());
	}
	
	private void sendRequested(String topic,boolean moreInfo) throws MqttException, JSONException, IOException {
		JSONObject j = new JSONObject();
		j.put("stato", automa.getStato());
		if(moreInfo) {
			j.put("learn", automa.getLearn());
			boolean antifurto = automa.getAntifurto();
			j.put("antifurto", antifurto);
			j.put("learn-trigger", learnTrigger);
			j.put("attiva-scenari", attivaScenari);
//			invio tutti gli scenari
			{
				ArrayList<File> allScenariFile = esec.getAllScenariAvailable();
				JSONArray arr = new JSONArray();
				for(File f : allScenariFile) {
					JSONObject scenarioData = new JSONObject();
					String scenNome = esec.getScenarioNome(f);
					System.out.println(scenNome);
					scenarioData.put("nome", !esec.isFileRenamed(scenNome)? scenNome.substring(0,28) : esec.removeData(scenNome));
					scenarioData.put("data", esec.getScenarioData(f));
					arr.put(scenarioData);
				}
				j.put("scenari-disponibili", arr);
			}
//			invio lo scenario attivo
			if(antifurto) {
				String scenarioAttivo = esec.getScenarioAttivo();
				if(scenarioAttivo != null && !scenarioAttivo.equals("none")) {
					JSONObject scenarioValori = new JSONObject();
//					System.out.println(scenarioAttivo);
					scenarioValori.put("nome", !esec.isFileRenamed(scenarioAttivo) ? scenarioAttivo.substring(0,28) : esec.removeData(scenarioAttivo));
					scenarioValori.put("data", esec.getDataScenarioAttivo());
					j.put("scenario-attivo", scenarioValori);
				}
			}
		}
//		Helper.sendMqttMessage(scenari.mqttClient, topic, j.toString());
//		publisher.aggiungiComando(topic,j.toString());
		scenari.sendMqttMessage(topic, j.toString());
	}

	private void renameLastScenario(JSONObject json) throws IOException, MqttException, JSONException {
		String nuovoNome = json.getString("nome");
		nuovoNome += nuovoNome.endsWith(".json") ? "" : ".json";
		ArrayList<File> available = esec.getAllScenariAvailable();
//		cerco l'ultimo scenario (sono nominati in base al giorno e all'ora)

		File max = available.get(0);
		String maxString = max.toString();
		for(File f : available) {
			String fString = f.toString();
//			System.out.println(fString+" .. "+maxString+" .. "+isFileRenamed(esec.getScenarioNome(f)));
			if(esec.isFileRenamed(f))//non mi interessano i file rinominati
				continue;
//			System.out.println(isFileRenamed(esec.getScenarioNome(max))+" [] "+(fString.compareToIgnoreCase(maxString) > 0));
			if(esec.isFileRenamed(max) || fString.compareToIgnoreCase(maxString) > 0) {
				max = f;
				maxString = fString;
			}
		}
		String nome = esec.getScenarioNome(max);
		String[] path = max.toString().split("/");
		StringBuilder rename = new StringBuilder();
		for(int i = 0; i< path.length-1; i++)
			rename.append(path[i]).append('/');
		LocalDateTime now = LocalDateTime.now();
		String date = now.getYear()+"-"+(now.getMonthValue() < 10 ? "0"+now.getMonthValue() : now.getMonthValue())+"-"+(now.getDayOfMonth() < 10 ? "0"+now.getDayOfMonth() : now.getDayOfMonth());
		rename.append(esec.removeExtension(nuovoNome)).append("---").append(date).append(".json");
//		System.out.println(rename.toString());
		boolean renamed = max.renameTo(new File(rename.toString()));
//		System.out.println("rinominato? "+renamed+" ; "+ nuovoNome +" ; "+ nome);
		JSONObject j = new JSONObject();
		String nuovoNomeSenzaEstensione = esec.removeData(esec.removeExtension(renamed ? nuovoNome : nome));
		j.put("nome", nuovoNomeSenzaEstensione);
		j.put("data", date);
		scenari.sendMqttMessage(Scenari.getMqttTree("from/","scenario/salva"), j.toString());
	}
	

}
